# conditional build - /usr/share/doc/rpm-4.2/conditionalbuilds
#   --with alignpatch	- patch it to allign results in --cronjob (default)
#   --without alignpatch - do not patch
# assign default value
%{!?_with_alignpatch: %{!?_without_alignpatch: %define _with_alignpatch 1}}

Summary:	Rootkit scans for rootkits, backdoors and local exploits.
Name:		rkhunter
Version:	1.0.7
Release:	1.mr700
Epoch:		0
License:	GPL
Group:          Applications/System
URL:		http://www.rootkit.nl/
Source0:	http://downloads.rootkit.nl/%{name}-%{version}.tar.gz
#Patch0:		rkhunter-1.0.6.mr700.patch # embeded
BuildArch:	noarch
Requires:	perl
Packager:	Doncho N. Gunchev <mr700@globalnet.bg>
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


%description
Rootkit scanner is scanning tool to ensure you for about 99.9%% you're
clean of nasty tools. This tool scans for rootkits, backdoors and local
exploits by running tests like:
	- MD5 hash compare
	- Look for default files used by rootkits
	- Wrong file permissions for binaries
	- Look for suspected strings in LKM and KLD modules
	- Look for hidden files
	- Optional scan within plaintext and binary files

Rootkit Hunter is released as GPL licensed project and free for everyone to use.


%prep
%setup -q -n %name
# Mr.700 - Activate results alignment in --cronjob
# Read: true if _with_alignpatch is defined, false if not defined.
%if %{?_with_alignpatch:1}%{!?_with_alignpatch:0}
#%patch0 -p1 -b .mr700
# I decided to embed the patch (it's small, no need of separate file)
%{__cat} <<EOF | %{__patch} -p1 -b -z .mr700
diff -prU3 rkhunter.old/files/rkhunter rkhunter/files/rkhunter
--- rkhunter.old/files/rkhunter	2004-04-13 18:22:00.000000000 +0300
+++ rkhunter/files/rkhunter	2004-04-19 14:09:17.000000000 +0300
@@ -381,16 +381,19 @@ EGREP="egrep"
         if [ "\${CRONJOB}" -eq 0 ]; then
 	    LAYOUT="\033[\${jump}C"
 	  else
+	    # Mr.700 - I think there's no rpm based distro
+	    # that does not have symlink /bin/sh -> /bin/bash
 	    # BASH-only compatible code
-	    #	    if [ "\${MYSHELL}" = "bash" ]
-	    #	      then
-	    #	        LAYOUT="                                                   "
-	    #	        LAYOUT="\${LAYOUT::\${jump}}"
-	    #	      else
-	    #	        LAYOUT="  "
-	    #	    fi
+	    if [ "\${MYSHELL}" = "bash" ]
+	      then
+	        # Mr.700: /bin/ps did not align, so I add 8 more spaces (for sure)
+	        LAYOUT="                                                           "
+	        LAYOUT="\${LAYOUT::\${jump}}"
+	      else
+	        LAYOUT="  "
+	    fi
 
-	    LAYOUT="  "
+	    # LAYOUT="  "
 
 	fi
       }
EOF
%endif


%build
#%%configure ...
# We have nothing to configure... yet...


%install
# Well... This could be a bit easier if the install
# script was able to handle DSTDIR for example...
mkdir -p ${RPM_BUILD_ROOT}/usr/local/{bin,etc,rkhunter}
mkdir -p ${RPM_BUILD_ROOT}/usr/local/rkhunter/{db,docs,scripts,tmp}
chmod a+rwx ${RPM_BUILD_ROOT}/usr/local/rkhunter/tmp
%{__install} -m750 -p files/rkhunter		${RPM_BUILD_ROOT}/usr/local/bin/rkhunter
%{__install} -m640 -p files/rkhunter.conf	${RPM_BUILD_ROOT}/usr/local/etc/rkhunter.conf

%{__install} -m750 -p files/backdoorports.dat	${RPM_BUILD_ROOT}/usr/local/rkhunter/db/backdoorports.dat
%{__install} -m750 -p files/defaulthashes.dat	${RPM_BUILD_ROOT}/usr/local/rkhunter/db/defaulthashes.dat
%{__install} -m750 -p files/mirrors.dat		${RPM_BUILD_ROOT}/usr/local/rkhunter/db/mirrors.dat
%{__install} -m750 -p files/os.dat		${RPM_BUILD_ROOT}/usr/local/rkhunter/db/os.dat
%{__install} -m750 -p files/md5blacklist.dat	${RPM_BUILD_ROOT}/usr/local/rkhunter/db/md5blacklist.dat

%{__install} -m640 -p files/CHANGELOG		${RPM_BUILD_ROOT}/usr/local/rkhunter/docs/CHANGELOG
%{__install} -m640 -p files/README		${RPM_BUILD_ROOT}/usr/local/rkhunter/docs/README
%{__install} -m640 -p files/WISHLIST		${RPM_BUILD_ROOT}/usr/local/rkhunter/docs/WISHLIST

%{__install} -m750 -p files/check_modules.pl	${RPM_BUILD_ROOT}/usr/local/rkhunter/scripts/check_modules.pl
%{__install} -m750 -p files/check_port.pl	${RPM_BUILD_ROOT}/usr/local/rkhunter/scripts/check_port.pl
%{__install} -m750 -p files/filehashmd5.pl	${RPM_BUILD_ROOT}/usr/local/rkhunter/scripts/filehashmd5.pl
%{__install} -m750 -p files/filehashsha1.pl	${RPM_BUILD_ROOT}/usr/local/rkhunter/scripts/filehashsha1.pl
%{__install} -m750 -p files/showfiles.pl	${RPM_BUILD_ROOT}/usr/local/rkhunter/scripts/showfiles.pl

# make a cron.daily file to mail us the reports
mkdir -p "${RPM_BUILD_ROOT}/%{_sysconfdir}/cron.daily"
cat > "${RPM_BUILD_ROOT}/%{_sysconfdir}/cron.daily/01-rkhunter" <<EOF
#!/bin/sh
/usr/local/bin/rkhunter --cronjob | /bin/mail -s 'rkhunter Daily Run' root
EOF
chmod a+x ${RPM_BUILD_ROOT}%{_sysconfdir}/cron.daily/01-rkhunter


%clean
rm -rf "$RPM_BUILD_ROOT"


%files
%defattr(-,root,root,-)
/usr/local/bin/rkhunter
%dir /usr/local/rkhunter
%dir /usr/local/rkhunter/db
%dir /usr/local/rkhunter/scripts
%dir /usr/local/rkhunter/docs/
%doc /usr/local/rkhunter/docs/CHANGELOG
%doc /usr/local/rkhunter/docs/README
%doc /usr/local/rkhunter/docs/WISHLIST
/usr/local/rkhunter/db/backdoorports.dat
/usr/local/rkhunter/db/defaulthashes.dat
/usr/local/rkhunter/db/mirrors.dat
/usr/local/rkhunter/db/os.dat
/usr/local/rkhunter/db/md5blacklist.dat
/usr/local/rkhunter/scripts/check_modules.pl
/usr/local/rkhunter/scripts/check_port.pl
/usr/local/rkhunter/scripts/filehashmd5.pl
/usr/local/rkhunter/scripts/filehashsha1.pl
/usr/local/rkhunter/scripts/showfiles.pl
%config(noreplace) %verify(not mtime) /usr/local/etc/rkhunter.conf
%{_sysconfdir}/cron.daily/01-rkhunter


%changelog
* Mon Apr 19 2004 Doncho N. Gunchev - 1.0.7-1.mr700
- added missing /usr/local/rkhunter/db/md5blacklist.dat
- 2DO: report that /etc/.aumixrc is not dangerous in RH/FC :)
  check /etc/rc.d/init.d/halt at line 1399 - # Save mixer settings...
- patched to align results in --cronjob, I think rpm based
  distros have symlink /bin/sh -> /bin/bash
- added --with/--without alignpatch for conditional builds
  (in case previous patch breaks something)

* Sat Apr 03 2004 Michael Boelen / Joe Klemmer - 1.0.x-0
- Update to 1.0.6

* Mon Mar 29 2004 Doncho N. Gunchev - 1.0.0-0
- initial .spec file


